/*
Flexivue 0.0.8
Copyright © 2019 Charles Koyeung <cenxky@gmail.com>
*/
(function(global, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(exports, require("vue")) : typeof define === "function" && define.amd ? define([ "exports", "vue" ], factory) : (global = global || self, 
  factory(global.Flexivue = {}, global.Vue));
})(this, function(exports, Vue) {
  "use strict";
  Vue = Vue && Vue.hasOwnProperty("default") ? Vue["default"] : Vue;
  var Application = function() {
    function Application(options) {
      this.vueClass = options.vue || Vue;
      this.vueClass.prototype.$instances || (this.vueClass.prototype.$instances = {});
    }
    Application.initialize = function(options) {
      return new Application(options);
    };
    Application.prototype.load = function(contexts) {
      var _this = this;
      contexts.forEach(function(context) {
        var identifier = context.identifier;
        var instance = context.instanceConstructor.initialize();
        var selector = instance.el || "[instance='" + identifier + "']";
        var element = document.querySelector(selector);
        if (element) {
          var vueInstance = new _this.vueClass(instance.load(element));
          _this.vueClass.prototype.$instances[identifier] = vueInstance;
        }
      });
    };
    return Application;
  }();
  var __assign = window && window.__assign || function() {
    __assign = Object.assign || function(t) {
      for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
      return t;
    };
    return __assign.apply(this, arguments);
  };
  var Instance = function() {
    function Instance() {
      this.data = {};
    }
    Instance.initialize = function() {
      return new this();
    };
    Instance.prototype.load = function(element) {
      var dataset = {};
      var givenData = tryToParse(element.getAttribute("data")) || element.dataset;
      for (var key in givenData) {
        dataset[key] = tryToParse(givenData[key]);
      }
      this.data = __assign({}, this.data, dataset);
      this.el = element;
      var plainInstance = {};
      var funsFrom = [ this, this.__proto__ ];
      funsFrom.forEach(function(obj) {
        Object.getOwnPropertyNames(obj).forEach(function(name) {
          plainInstance[name] = obj[name];
        });
      });
      return plainInstance;
    };
    return Instance;
  }();
  function tryToParse(value) {
    try {
      return JSON.parse(value);
    } catch (error) {
      return value;
    }
  }
  exports.Application = Application;
  exports.Instance = Instance;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
});
