export function definitionsFromContext(context) {
    return context
        .keys()
        .map(function (key) { return definitionForModuleWithContextAndKey(context, key); })
        .filter(function (value) { return value; });
}
function definitionForModuleWithContextAndKey(context, key) {
    var identifier = identifierForContextKey(key);
    if (identifier) {
        return definitionForModuleAndIdentifier(context(key), identifier);
    }
}
function definitionForModuleAndIdentifier(module, identifier) {
    var instanceConstructor = module.default;
    if (typeof instanceConstructor == "function") {
        return { identifier: identifier, instanceConstructor: instanceConstructor };
    }
}
export function identifierForContextKey(key) {
    var logicalName = (key.match(/^(?:\.\/)?(.+)(?:\..+?)$/) || [])[1];
    if (logicalName) {
        return logicalName.replace(/\//g, "--");
    }
}
//# sourceMappingURL=index.js.map